
#ifndef QUESTAO_H
#define QUESTAO_H

#define Q_STR_RESPOSTA "resposta"
#define Q_STR_TIPO     "tipo"

#include <string>
#include <iostream>
#include <sstream>

using namespace std;

enum TipoQuestao { Q_GENERICA = 0 , Q_DESCRITIVA = 1 , Q_SIMNAO = 2, Q_ALTERNATIVA = 3 };

/**
  * class Questao
  * Classe Abstrata que serve como base para outras questões
  */

class Questao
{
public:
    
   /**
    * @param  id
    */
   Questao (int id = 0 );
    
   virtual ~Questao ( );

   /**
    * Deve ler os dados da questão
    * @return virtual void
    */
   virtual void lerDados ( ) = 0;

   /**
    * Retorna string html que representa descricao da questão + getBodyRespHtml()
    * @return string
    */
   string getHtml ( ) const;
   
   /**
    * Set the value of m_enunciado
    * Enunciado da questão
    * @param new_var the new value of m_enunciado
    */
   void setEnunciado ( string new_var );

   /**
    * Get the value of m_enunciado
    * Enunciado da questão
    * @return the value of m_enunciado
    */
   string getEnunciado ( ) const;

   /**
    * Get the value of m_id
    * identificador do objeto
    * @return the value of m_id
    */
   int getId ( ) const;

   /**
    * Set the value of m_tipo
    * @param new_var the new value of m_tipo
    */
   void setTipo ( TipoQuestao new_var );

   /**
    * Get the value of m_tipo
    * @return the value of m_tipo
    */
   TipoQuestao getTipo ( ) const;
   
private:
   
   string m_enunciado; // Enunciado da questão
   int m_id; // identificador do objeto
   TipoQuestao m_tipo; //tipo da questao

   /**
    * Deve retornar parte do html com as respostas possíveis
    * @return virtual string
    */
   virtual string getBodyRespHtml ( ) const = 0;
};

#endif // QUESTAO_H
