#include "Questionario.h"
/**
 * @param  id
 */
Questionario::Questionario (string id) : m_id(id) {}

Questionario::~Questionario() {
   Questoes::iterator i;
   for (i=questoes.begin(); i!=questoes.end(); i++) {
      delete *i;
   }   
}

/**
 * Set the value of m_titulo
 * Titulo do Questionário
 * @param new_var the new value of m_titulo
 */
void Questionario::setTitulo ( string new_var ) {
   m_titulo = new_var;
}

/**
 * Get the value of m_titulo
 * Titulo do Questionário
 * @return the value of m_titulo
 */
string Questionario::getTitulo ( ) {
   return m_titulo;
}

/**
 * Set the value of m_id
 * identificador do objeto
 * @param new_var the new value of m_id
 */
void Questionario::setId ( string new_var ) {
   m_id = new_var;
}

/**
 * Get the value of m_id
 * identificador do objeto
 * @return the value of m_id
 */
string Questionario::getId ( ) {
   return m_id;
}

/**
 * @param  arquivo
 */
void Questionario::saveToHtml (string arquivo ) {
   fstream htmlFile;
   
   htmlFile.open(arquivo.c_str(), fstream::out);
   if (htmlFile.fail()) {
      throw string("Não foi possível criar " + arquivo);
   }  
   htmlFile << "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">";
   htmlFile << "<html><head>";
   htmlFile << "<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=utf-8\">";
   htmlFile << "<LINK REL=\"stylesheet\" TYPE=\"text/css\" HREF=\"questionario.css\">";
   htmlFile << "<title>" << m_titulo << "</title></head><body>";
   htmlFile << "<h1>"<< m_titulo <<"</h1>";
   htmlFile << "<Form method=\"POST\" ACTION=\"cgi-bin/questgen.cgi\">";
   htmlFile << "<input type=\"hidden\" name=\"quest.count\" value=\""<< questoes.size() <<"\">";
   Questoes::iterator i;
   for (i=questoes.begin(); i!=questoes.end(); i++) {
      htmlFile << "<div class=\"questao\">";
      htmlFile << (**i).getHtml();
      htmlFile << "</div>";
   }
   htmlFile << "<input type=\"submit\" name=\"submit\" >";
   htmlFile << "</form>";
   htmlFile << "</body></html>";
   htmlFile.close();
}

/**
 * Lê o questionario inteiro
 */
void Questionario::lerDados ( ) {
   int n=0;
   
   cout << "Digite o titulo do questionario: " << endl;
   cout << ">>> ";
   getline(cin,m_titulo);
      
   cout << "Digite o numero de questões (no mínimo 1): " << endl;
   cout << ">>> ";
   cin >> n;
   cin.ignore();
   while (n<1) {
      cout << "Valor inválido. No mínimo uma." << endl;
      cout << ">>> ";
      cin >> n;
      cin.ignore();
   }
   //Leitura da questões   
   int i;
   for (i=1; i<=n; i++) {
      Questao *q;
      int tipo = 0;
      cout << "Qual o tipo da questão " << i << "?" << endl;
      cout << "1. Questao Descritiva " << endl;
      cout << "2. Questao Sim/Não " << endl;
      cout << "3. Questao Alternativa " << endl;
      cout << ">>> ";
      cin >> tipo;
      cin.ignore();
      while ((tipo<1) || (tipo>3)) {
         cout << "Valor inválido. " << endl;
         cout << ">>> ";
         cin >> tipo;
         cin.ignore();
      }
      switch (tipo) {
         case Q_DESCRITIVA: 
              q = new QuestaoDescritiva(i);  
              break;
         case Q_SIMNAO: 
              q = new QuestaoSimNao(i);  
              break;
         case Q_ALTERNATIVA: 
              q = new QuestaoAlternativa(i);  
              break;     
         default:
              continue;      
      }
      q->lerDados();
      questoes.push_back(q);
      cout << endl;
   }        
}




