
#ifndef QUESTIONARIO_H
#define QUESTIONARIO_H

#include "Questao.h"
#include "QuestaoDescritiva.h"
#include "QuestaoSimNao.h"
#include "QuestaoAlternativa.h"
#include <string>
#include <vector>
#include <iostream>
#include <fstream>


using namespace std;

/**
  * class Questionario
  * Abriga uma ou mais questões
  */

class Questionario
{

private:
   typedef vector<Questao*> Questoes;
   Questoes questoes;
   string m_titulo; // Titulo do Questionário
   string m_id; // identificador do objeto
   
public:
   /**
    * @param  id
    */
   Questionario (string id = "questionario" );
   
   virtual ~Questionario();
   
   /**
    * @param  arquivo
    */
   void saveToHtml (string arquivo );

   /**
    * Lê o questionario inteiro
    */
   void lerDados ( );
   /**
    * Set the value of m_titulo
    * Titulo do Questionário
    * @param new_var the new value of m_titulo
    */
   void setTitulo ( string new_var );

   /**
    * Get the value of m_titulo
    * Titulo do Questionário
    * @return the value of m_titulo
    */
   string getTitulo ( );


   /**
    * Set the value of m_id
    * identificador do objeto
    * @param new_var the new value of m_id
    */
   void setId ( string new_var );

   /**
    * Get the value of m_id
    * identificador do objeto
    * @return the value of m_id
    */
   string getId ( );

};

#endif // QUESTIONARIO_H
