#include "CGImap.h"
#include <iostream>
#include <string>
#include <iostream>
#include <fstream>
#include <sstream>
#include <stdio.h>
#include <time.h>
#include <ctype.h>

using namespace std;

/**
 Retorna um nome único razoável para o arquivo
 baseado no número de segundo passados desde 1970
*/
string getUnicNameForFile() {
   stringstream s;
   time_t seconds;
   seconds = time (NULL);
   s << "questdata" << (long)seconds << ".csv";
   return s.str();
}

/**
 Converte um valor em inteiro para string
*/ 
string intToStr(int valor) {
   stringstream s;
   s << valor;
   return s.str();
}

/**
 Salva um map de parâmetros para um arquivo de dados
 Arquivo é formatado em csv onde cada linha é da formatado
 [tipo da questao], [valor de resposta]
 tipo da questao é um numero
 e valor da resposta pode ser um número ou uma string
 Pode gerar exceção do tipo string
*/
void saveFormToFile(CGImap& map) {
   fstream dataFile;
   dataFile.open(getUnicNameForFile().c_str(), fstream::out);
   cout << getUnicNameForFile() << endl;
   if (dataFile.fail()) {
      throw string("Arquivo não pode ser criado. Verifique as permissões do arquivo.");
   }
   if (map["quest.count"] == "") {
      throw string("Arquivo não pode ser salvo. Número de questoes não definido.");
   }
   int n = atoi(map["quest.count"].c_str());
   for (int i=1; i<=n; i++) {
       string tipo = "questao" + intToStr(i) + ".tipo";
       string resposta = "questao" + intToStr(i) + ".resposta";
       dataFile << map[tipo] << ",";
       dataFile << map[resposta] << endl; 
   }
   dataFile.close();
}


/**
 Função principal
 Obtem dados brutos do Post, cria um CGImap e salva um arquivo com respostas do questionario
*/
int main() {
  cout << "Content-type: text/plain\n" << endl;
  try {
      Post p; 
      CGImap query(p);
      try {
         saveFormToFile(query);
      } catch (string erro) {
         cout << "Erro: " << erro << endl;
         exit(1);
      }
  } catch (string erro) {
      cout << "Erro: " << erro << endl;
      exit(2);
  } catch (...) {
      cout << "Erro desconhecido";
      exit(3);
  }
  cout << "Formulário enviado com sucesso!" << endl;
  exit(0);
} 
